*****************************************************;
* M&S K3@ᐔ݌vV~[V              ; 
* 2010.3.9 QCyѓmFς                                                   ;
* K.KOMATSU                                          ;
*****************************************************;

*z팱Ҕwif[^ǂݍ;
DATA Background;
 infile "C:\NONMEM\2009_MPU_Text\04_PD3Simulation_091220\Exercise_2b\SAS\MS_DATA_2007_for_Sim.csv"
 dlm="," firstobs=2;
 input ID TIME DOS RACE AGE WGHT BSA CCR ALBU SMOK EED;
RUN;

%LET nSim= 100;   *JԂ;
%LET nDose= 8;    *pʐ̐;
%LET number=150;  *Q̔팱Ґ;
%LET nAll =%EVAL(&nDose * &number); *1JԂ̔팱Ґ;

*dăTvOAResampled_1֊i[;
ods listing close;
PROC SURVEYSELECT data=Background out=Resampled_1
 method=URS rep=%EVAL(&nSim) n=%EVAL(&nAll) outhits;
RUN;

*pʂ̊t̂߂̗RUAResampled_2֊i[;
DATA Resampled_2;
 set Resampled_1;
 R = RAND("UNIFORM");
RUN;

*Ƀ\[gAResampled_3;
PROC SORT data=Resampled_2 out=Resampled_3;by Replicate R;RUN;

*pʊt̂߂̗pʃf[^ZbgADose쐬;
*񐔂킹č쐬;
DATA Dose;
 do Replicate = 1 to &nSim;
  do simDOSE = 0,25,50,75,100,125,150,200;
	  do i = 1 to &number;
		output;
	  end;
	end;
 end;
RUN;

*pʂResampled_3}[W邱Ƃŗpʂt;
DATA Resampled_4;
 merge Dose Resampled_3;
RUN;

*PKV~[V;
DATA Resampled_5;
 set Resampled_4;
 TVCL = 56.2 - 0.25 * (AGE - 56.4);
 CL = TVCL * EXP(RAND("NORMAL",0,sqrt(0.05)));
 TV = 65.4 + (BSA-2.1) * 2.51;
 V = TV * EXP(RAND("NORMAL",0,sqrt(0.014)));
 TKA = 0.23;
 if EED = 2 then TKA=0.23*1.54;
 KA = TKA * EXP(RAND("NORMAL",0,sqrt(0.012)));
 AL1=0.84*EXP(RAND("NORMAL",0,sqrt(0.01)));
 SC = V;
 TF1 = 1;
 if simDose ge 100 then TF1 = (100 - (simDose-100)*0.387)/100;
 if simDOSE eq 200 then TF1 = 0.613;
 F1=TF1*EXP(RAND("NORMAL",0,sqrt(0.02)));
 AUC=simDOSE*1000*F1/CL;
RUN;

*PDV~[V;
DATA Resampled_6;
 set Resampled_5;
 AUCN = AUC / 1000;
 WKS = TIME / 24/ 7;
 BAS = -4.02 + 0.756 * WKS -0.225 * (AGE-56.4);
 PROP = 3.16;
 EMAX = 4.81;
 EC50 = 1.17;
 if SMOK >= 3 then EC50 = EC50*1.83;

 EDC = EMAX * AUCN/(EC50 + AUCN);
 LGT = BAS + EDC + RAND("NORMAL",0, sqrt(5.86));
 LGTF = LGT + PROP;
 PP = 1 / (1 + EXP(-LGT));
 PF = 1 / (1 + EXP(-LGTF));
 R=RAND("UNIFORM");

* PD3,PD2f[^̊i[ ;
 if R >= PF then PD3 = 1;
 else if R >= PP then PD3  =2;
 else PD3 = 3;

 if PD3 = 3 or PD3 = 2 then PD2 = 1;
 else PD2 = 0;

* 2̂߂̕ϐEFF3, EFF2̍쐬;
* eLXg3l̗ɂEFF3ɂPlaceboƑΏۗpʂŃ2肷;
 EFF3 = 0; if PD3 = 3 then EFF3 = 1;
 EFF2 = 0; if PD2 = 1 then EFF2 = 1;
RUN;

PROC SORT data=Resampled_6;by Replicate simDOSE;RUN;


%LET testD=100;
* 2̎s;
ods listing CLOSE;
PROC FREQ data=Resampled_6;
 by Replicate;
 where simDOSE = 0 or simDOSE=&testD;
 tables EFF3 * simDose / chisq nopercent nocol;
 output out=out_&testD pchi;
RUN;

* LӍ̂EȂ̔ ;
DATA Summary;
 set out_&testD;
 if P_PCHI < 0.05 then JUDGE = 1;
 else JUDGE=0;
RUN;

* o͂̌vZ;
ods listing;
PROC FREQ data=Summary;
 table JUDGE;
RUN;
